program reassemble;

uses crt, dos;

var inp, tr, out: text; {puvodni, prelozene, nove}
{format prelozeneho je: co radek, to neco prelozeneho...}
{predp., ze zustal zachovan pocte radku.}
{mam pocit, ze to polaci zachovali.}
    InExt, TrExt, OutExt: string;
    DirInfo: SearchRec;
    name: string[12];
    s: string;
    c: longint;

    {najdu uvozovku - k ni bud musi dvojtyecka (pred ni), nebo nic}
    {procedury- 1. nacti radek, je to zacatek? ne, znovu dle bodu 1.
        tiskni stary a nacti novy- je to konec? ne, dle bodu 2.
        jo, znovu dle bodu 1. az do konce vstupniho souboru}

function IsBegin: boolean;
var nasli: boolean;
    i: byte;
    pos1, pos2: byte;
begin
  nasli:= False;
  IsBegin:= False;
(*  while not eof(inp) and not nasli do begin
    {nacteme radek:}
    readln(inp,s);
    {odrusime mezery etc.:}*)
    i:=1;
    while (s[i]=' ')or(s[i]=#9)or(s[i]=#13) do inc(i);
    {pokud to bykla poznamka, budeme ji ignorovat:}
    if s[i]='{' then exit;
    {musi tam byt uvozovky a pred nimi dvojtecka:}
    pos2:= pos('"', s);
    pos1:= pos(':', s);
    if(pos1<>0)and(pos2<>0)and(pos1<pos2) then begin
      {hura, byly tam!}
      {mezi dvojteckou a uvozovkama muze byt jedine volne misto:}
      for i:= pos1+1 to pos2-1 do if not((s[i]=' ')or(s[i]=#9)or(s[i]=#13)) then exit;
      nasli:= True;
    end;
(*  end;          *)
  IsBegin:= nasli;
end;

function IsTitle : boolean;
var ss : string;
    i : byte;
begin
  istitle:=false;
  ss:=s;
  i:=1;
  if s[i]='{' then exit; {poznamku ignorujeme}
  for i:=1 to length(s) do ss[i]:=upcase(s[i]);
  istitle:= (pos('TITLE ',ss)<>0);
end;

function IsRemark : boolean;
begin
  IsRemark:= (s[1]='{');
end;

function IsEnd(var f: text): boolean;
begin
  IsEnd:= false;
  readln(f,s);
  if s[1]='{' then exit; {poznamku ignorujeme}
  IsEnd:=pos('"', s)<>0;
end;

function OnlyOneLine: boolean;
var i: byte;
begin
  i:= Length(s);
  while (s[i]=' ')or(s[i]=#9) do dec(i);
  OnlyOneLine:= s[i]='"';
end;

procedure minc(var i: longint);
begin
  inc(i);
end;

procedure Process;
begin
  assign(inp, name);
  reset(inp);
  name[Length(name)]:= TrExt[3];
  name[Length(name)-1]:= TrExt[2];
  name[Length(name)-2]:= TrExt[1];
  assign(tr, name);
  reset(tr);
  name[Length(name)]:= OutExt[3];
  name[Length(name)-1]:= OutExt[2];
  name[Length(name)-2]:= OutExt[1];
  assign(out, name);
  rewrite(out);
  repeat
    readln(inp,s);
    {jenom prozeneme vsechny radky, dokud nenajdeme zacatek nebo titulek:}
    while not IsBegin and not IsTitle and not eof(inp) do begin
      writeln(out, s); {writeln(s);} readln(inp, s);
    end;
    if eof(inp) then begin writeln(out, s); {writeln(s);} break; end;
    {kdyz mluvi jen na jednom radku nebo to je titulek, tak jsme uz vynechali}
    {kdyz mluvi pres vic radku, tak je vynechame vsecky:}
    if not(OnlyOneLine or istitle) then begin
      while not IsEnd(inp) and not eof(inp) do; {IsEnd bude po fajlu putovat samo}
    end;
    {a tedka bysme meli doplnit vsecko z prelozeneho:}
    readln(tr, s); minc(c); writeln(out, s); {writeln(s);}
    {poznamku jenom zopakujeme:}
    if IsRemark then begin readln(tr, s); minc(c); writeln(out, s); {writeln(s);} end;
    {protoze polaci nedavali za title mezeru, doplnime ji:}
    s:= s+' ';
    if not(IsTitle or OnlyOneLine) then begin
      while not IsEnd(tr) and not eof(tr) do begin
        minc(c); writeln(out, s); {writeln(s);}
      end;
      minc(c); writeln(out, s); {writeln(s);}
    end;
  until eof(inp);
  close(inp);
  close(tr);
  close(out);
end;

begin
  InExt:= ParamStr(1);
  TrExt:= ParamStr(2);
  OutExt:= ParamStr(3);
  if(ParamCount<>3)or(Length(InExt)<>3)or(Length(TrExt)<>3)or(Length(OutExt)<>3) then begin
    writeln('Znovusestaveni zdrojaku hry. Parametry:');
    writeln('<3 zn.pripona puvodni> <3 zn.prip. prelozeny> <3 zn.prip. novy>');
    halt;
  end;
  FindFirst('*.'+InExt, AnyFile, DirInfo); { Same as DIR *.PAS }
  while DosError=0 do begin
    Writeln(DirInfo.Name);
    name:= DirInfo.Name;
    Process;
    FindNext(DirInfo);
  end;
  writeln('Vsechno je v oukeju.');
end.
